/**
 * @file main.c
 * @author WHXY
 * @brief
 * @version 0.1
 * @date 2024-08-07
 *
 * @copyright Copyright (c) 2021
 *
 */
/*******************************************************************************
*
* 代码许可和免责信息
* 武汉芯源半导体有限公司授予您使用所有编程代码示例的非专属的版权许可，您可以由此
* 生成根据您的特定需要而定制的相似功能。根据不能被排除的任何法定保证，武汉芯源半
* 导体有限公司及其程序开发商和供应商对程序或技术支持（如果有）不提供任何明示或暗
* 含的保证或条件，包括但不限于暗含的有关适销性、适用于某种特定用途和非侵权的保证
* 或条件。
* 无论何种情形，武汉芯源半导体有限公司及其程序开发商或供应商均不对下列各项负责，
* 即使被告知其发生的可能性时，也是如此：数据的丢失或损坏；直接的、特别的、附带的
* 或间接的损害，或任何后果性经济损害；或利润、业务、收入、商誉或预期可节省金额的
* 损失。
* 某些司法辖区不允许对直接的、附带的或后果性的损害有任何的排除或限制，因此某些或
* 全部上述排除或限制可能并不适用于您。
*
*******************************************************************************/
/******************************************************************************
 * Include files
 ******************************************************************************/
#include "..\inc\main.h"
#include "cw32l010_crc.h"
#include "cw32l010_sysctrl.h"

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/******************************************************************************
 * Global variable definitions (declared in header file with 'extern')
 ******************************************************************************/

/******************************************************************************
 * Local type definitions ('typedef')
 ******************************************************************************/

/******************************************************************************
 * Local function prototypes ('static')
 ******************************************************************************/


/******************************************************************************
 * Local variable definitions ('static')                                      *
 ******************************************************************************/

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/*****************************************************************************
 * Function implementation - global ('extern') and local ('static')
 ******************************************************************************/


/**
 ******************************************************************************
 ** \brief  Main function of project
 **
 ** \return uint32_t return value, if needed
 **
 ** 计算CRC16 / CRC32
 **
 ******************************************************************************/

//=========================================================================

uint32_t tmp1;

//=========================================================================

int32_t main(void)
{
    uint8_t  Raw08[8] = { 0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77 };
    //=========================================================================
    //enable CRC CLK    
    __SYSCTRL_CRC_CLK_ENABLE();
    //=========================================================================
    //CRC16_IBM
    tmp1 = CRC16_Calc_8bit(CRC16_IBM, Raw08, 8);      //按Byte计算CRC16 计算结果0xE16C
    __asm("BKPT  0"); //请在此出观察tmp1的值



    //=========================================================================
    //CRC16_MAXIM
    tmp1 = CRC16_Calc_8bit(CRC16_MAXIM, Raw08, 8);      //按Byte计算CRC16 计算结果0x1E93
    __asm("BKPT  0");  //请在此出观察tmp1的值


    //=========================================================================
    //CRC16_USB
    tmp1 = CRC16_Calc_8bit(CRC16_USB, Raw08, 8);      //按Byte计算CRC16 计算结果0x15D3
    __asm("BKPT  0");  //请在此出观察tmp1的值


    //=========================================================================
    //CRC16_MODBUS
    tmp1 = CRC16_Calc_8bit(CRC16_MODBUS, Raw08, 8);      //按Byte计算CRC1 计算结果0xEA2C
    __asm("BKPT  0");  //请在此出观察tmp1的值


    //=========================================================================
    //CRC16_CCITT
    tmp1 = CRC16_Calc_8bit(CRC16_CCITT, Raw08, 8);      //按Byte计算CRC16 计算结果0x868F
    __asm("BKPT  0");  //请在此出观察tmp1的值


    //=========================================================================
    //CRC16_CCITTFALSE
    tmp1 = CRC16_Calc_8bit(CRC16_CCITTFALSE, Raw08, 8);      //按Byte计算CRC16 计算结果0x5CFF
    __asm("BKPT  0");  //请在此出观察tmp1的值


    //=========================================================================
    //CRC16_X25
    tmp1 = CRC16_Calc_8bit(CRC16_X25, Raw08, 8);      //按Byte计算CRC16 计算结果0x05FC
    __asm("BKPT  0");  //请在此出观察tmp1的值


    //=========================================================================
    //CRC16_XMODEM
    tmp1 = CRC16_Calc_8bit(CRC16_XMODEM, Raw08, 8);      //按Byte计算CRC16 计算结果0x6DC1
    __asm("BKPT  0");  //请在此出观察tmp1的值


    while (1)
    {
        ;
    }
}


/******************************************************************************
 * EOF (not truncated)
 ******************************************************************************/
#ifdef  USE_FULL_ASSERT
 /**
   * @brief  Reports the name of the source file and the source line number
   *         where the assert_param error has occurred.
   * @param  file: pointer to the source file name
   * @param  line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
    /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
       tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
       /* USER CODE END 6 */
}
#endif

